<template>
    <v-container class="inscription">
        <v-row align="center" justify="center" class="pa-5">
            <v-flex>
                <h1 class="heading text-center">{{ this.player === null ? "Register" : "Update your informations"}}</h1>
                <hr class="ma-4"/>
                <v-form ref="form" v-model="valid" lazy-validation>
                    <v-text-field outlined
                                  v-model="email"
                                  label="Mail"
                                  type="mail"
                                  :rules="emailRules"
                                  :counter="255"
                                  :error-messages="errorEmail"
                                  required
                    ></v-text-field>

                    <v-text-field outlined
                                  v-model="pseudo"
                                  label="Pseudo"
                                  :rules="pseudoRules"
                                  :counter="255"
                                  required
                    ></v-text-field>

                    <v-text-field outlined
                                  v-model="password"
                                  :append-icon="show ? 'mdi-eye' : 'mdi-eye-off'"
                                  :type="show ? 'text' : 'password'"
                                  label="Password"
                                  @click:append="show = !show"
                                  :rules="passwordRules"
                                  :counter="255"
                                  required
                                  clearable
                                  @keyup.enter="validate"
                    ></v-text-field>

                    <div class="text-center">
                        <v-btn :disabled="!valid" color="success" class="mr-4" @click="validate">
                            {{ this.player === null ? "Register" : "Update"}}
                        </v-btn>

                        <v-btn color="error" class="mr-4" @click="reset">
                            Reset Form
                        </v-btn>

                        <v-btn color="warning" @click="resetValidation">
                            Reset Validation
                        </v-btn>
                    </div>

                    <br/>
                    <hr/>
                    <br/>

                    <div v-if="this.player !== null" class="text-center">
                        <v-btn color="error" class="mr-4" @click="deleteAccount">
                            <v-icon left>mdi-delete-outline</v-icon>
                            Delete your account
                        </v-btn>
                    </div>
                </v-form>
            </v-flex>
        </v-row>
    </v-container>
</template>

<script>
    import Services from "../services/index";
    import {SET_PLAYER} from "../store/mutations.type";
    import {RESET_PLAYER} from "../store/actions.type";
    import sha256 from "crypto-js/sha256";

    export default {
        name: "Inscription",
        data: function () {
            return {
                valid: false,
                pseudo: null,
                pseudoRules: [
                    v => ((this.player !== null) || !!v) || 'Pseudo is required',
                    v => (v && v.length < 255) || 'Pseudo must be less than 255 characters',
                    // v => this.isPseudoAvailable(v) || 'This pseudo is already taken.',
                ],
                email: null,
                emailRules: [
                    v => !!v || 'E-mail is required',
                    v => /.+@.+\..+/.test(v) || 'E-mail must be valid',
                    v => (v && v.length < 255) || 'E-mail must be less than 255 characters',
                ],
                errorEmail: "",
                password: null,
                passwordRules: [
                    v => ((this.player !== null) || !!v) || 'Password is required',
                    v => ((this.player !== null) || (v && v.length < 255)) || 'Password must be less than 255 characters',
                ],
                show: false,
            }
        },
        methods: {
            addPlayer: function () {
                if (this.email != null && this.pseudo != null && this.password != null) {
                    Services.addPlayer(this.pseudo, this.email, sha256(this.password).toString()).then((data) => {
                        Services.getPlayer(data.id).then(data => {
                            this.$store.commit(SET_PLAYER, data);
                            this.$router.push("/");
                        })
                    }).catch((e) => {
                        this.$notify({
                            type: "error",
                            title: "Inscription failed",
                            text: e.toString()
                        })
                    });
                } else
                    this.valid = false;
            },
            updatePlayer: function () {
                Services.updatePlayer(
                    this.player.id,
                    this.pseudo || this.player.name,
                    this.email || this.player.login,
                    (this.password != null || this.password !== "") ? sha256(this.password).toString() : this.player.password)
                    .then(() => {
                        this.$store.commit(SET_PLAYER, {
                            id: this.player.id,
                            name: this.pseudo || this.player.name,
                            login: this.email || this.player.login,
                            password: (this.password != null || this.password !== "") ? sha256(this.password).toString() : this.player.password
                        });
                        this.$router.push("/");
                    }).catch((e) => {
                    this.$notify({
                        type: "error",
                        title: "Update failed",
                        text: e.toString()
                    })
                });
            },
            validate: function () {
                if (this.player === null)
                    this.addPlayer();
                else
                    this.updatePlayer();
            },
            reset: function () {
                this.$refs.form.reset();
                this.valid = false;
            },
            resetValidation: function () {
                this.$refs.form.resetValidation();
                this.valid = false;
            },
            deleteAccount: function () {
                Services.rmPlayer(this.player.id).then(() => {
                    this.$store.dispatch(RESET_PLAYER);
                    this.$router.push("/");
                }).catch((e) => {
                    this.$notify({
                        type: "error",
                        title: "Fail to remove",
                        text: e.toString()
                    })
                });
            }
        },
        computed: {
            player: function () {
                return this.$store.getters.player
            }
        },
        watch: {
            email(val) {
                if (this.player === null)
                    Services.isEmailAvailable(val).then(data => {
                        this.errorEmail = data.result ? "This email is already taken." : "";
                    });
            }
        },
        mounted() {
            if (this.player !== null) {
                this.pseudo = this.player.name;
                this.email = this.player.login;
            }
        }
    }
</script>

<style scoped>
    .inscription {
        background-color: #222222;
        border-radius: 1em;
        max-width: 75%;
    }

    @media (max-width: 640px) {
        .inscription {
            max-width: 95%;
        }
    }

    @media (max-width: 1024px) {
        .inscription {
            max-width: 75%;
        }
    }
</style>
